// CheckListBox.h: interface for the CCheckListBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHECKLISTBOX_H__76D27425_4393_4A35_8C70_7C01E7718CB1__INCLUDED_)
#define AFX_CHECKLISTBOX_H__76D27425_4393_4A35_8C70_7C01E7718CB1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ATLBASE.H>
#include <atlapp.h>

extern CAppModule _Module;

#include <ATLWIN.H>
#include <atlmisc.h>
#include <atlcrack.h>
#include <atlctrls.h>
#include <atlframe.h>

#include <vector>
#include <string>

using std::string;

/*!
    \brief   
*/
typedef CWinTraits<WS_VISIBLE | WS_CHILD | WS_BORDER | WS_VSCROLL | LBS_OWNERDRAWFIXED | LBS_HASSTRINGS> CheckStyles;

/*!
    \brief  ListBox'  
*/
class CCheckListBox : public CWindowImpl<CCheckListBox, CListBox, CheckStyles>, 
					public COwnerDraw<CCheckListBox>
{
private:
	enum
	{
		LEFTBORDERCHECK = 2,				///<    
	};

	typedef std::vector<BOOL> FLAGS;

	FLAGS m_Flags;							///<   

	/*!
	    \brief ,      .

		 :
			WPARAM - int	 
			LPARAM - BOOL	  
	*/
	DWORD m_CheckMessage;
public:

	DECLARE_WND_SUPERCLASS(NULL, CListBox::GetWndClassName())
		
	BEGIN_MSG_MAP_EX(CCheckListBox)
		MSG_WM_CREATE (OnCreate);

		MSG_WM_LBUTTONDOWN(OnLButtonDown)

		CHAIN_MSG_MAP_ALT(COwnerDraw<CCheckListBox>, 1)
		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()

	void DrawItem(LPDRAWITEMSTRUCT pDIS);
	void OnLButtonDown (UINT key, CPoint point);

	BOOL OnCreate (LPCREATESTRUCT lpCreateStruct);

public:
	CCheckListBox();
	virtual ~CCheckListBox();

	/*!
	    \brief  .
		\param str  
		\param Check     
	*/
	void AddString (const char *str, BOOL Check = TRUE);

	/*!
	    \brief  .
		\param Number	 
	*/
	void DeleteString (int Number);

	/*!
	    \brief ,   
		\param Number	 
	*/
	BOOL IsCheck(int Number);

	/*!
	    \brief  .

		\param hWndParent	
		\param Message		,       
		\param rect			  
		\param dwStyle		 
		\param dwExStyle	 
		\param MenuOrID		 
	*/
	HWND Create(HWND hWndParent, DWORD Message, _U_RECT rect = NULL,
		LPCTSTR szWindowName = NULL, DWORD dwStyle = 0, DWORD dwExStyle = 0,
		_U_MENUorID MenuOrID = 0U);

	/*!
	    \brief  
	*/
	void Clear();
};

#endif // !defined(AFX_CHECKLISTBOX_H__76D27425_4393_4A35_8C70_7C01E7718CB1__INCLUDED_)
